

#things for death system
#target random player (for death system)
execute unless entity @s[tag=fancy_tp_cr_pl] run tag @a[scores={fancy_tp_die=0,fancy_tp_timer=0..},tag=fancy_tp,limit=1,sort=random,tag=!fancy_tp_cr_pl0] add fancy_tp_cr_pl

#tp armor_stand to player with same id (for death system)
execute as @e[type=minecraft:armor_stand,tag=fancy_tp_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_cr_pl,scores={fancy_tp_die=..0}] fancy_tp_pl_id run tp @s @a[limit=1,tag=fancy_tp_cr_pl,scores={fancy_tp_die=..0}]


#remove tags (for death system)
tag @s remove fancy_tp_cr_pl

#detect player change world
execute in minecraft:the_nether as @s[nbt={SpawnDimension:"minecraft:the_nether"},tag=fancy_tp_overworld] run tag @s add fancy_tp_cancel
execute in minecraft:the_nether as @s[nbt={SpawnDimension:"minecraft:the_nether"},tag=fancy_tp_overworld] run tag @s add fancy_tp_nether
execute in minecraft:the_nether as @s[nbt={SpawnDimension:"minecraft:the_nether"},tag=fancy_tp_overworld] run tag @s remove fancy_tp_overworld

execute in minecraft:overworld as @s[nbt={SpawnDimension:"minecraft:overworld"},tag=fancy_tp_nether] run tag @s add fancy_tp_cancel
execute in minecraft:overworld as @s[nbt={SpawnDimension:"minecraft:overworld"},tag=fancy_tp_nether] run tag @s add fancy_tp_overworld
execute in minecraft:overworld as @s[nbt={SpawnDimension:"minecraft:overworld"},tag=fancy_tp_nether] run tag @s remove fancy_tp_nether

#dead body
execute at @s at @e[type=minecraft:armor_stand,tag=fancy_tp_dead,distance=0..30] run particle minecraft:item redstone ~ ~1.6 ~0.7 0.1 0.1 0.1 0.1 1 force @a
execute at @s at @e[type=minecraft:armor_stand,tag=fancy_tp_dead,distance=0..30] run particle minecraft:dust 1 0 0 1 ~ ~1.5 ~0.7 0.15 0.1 0.15 0.1 1 force @a

execute at @s[gamemode=!spectator] positioned ~ ~-1 ~ as @e[type=minecraft:armor_stand,tag=fancy_tp_dead,distance=0..1.2,tag=!fancy_tp_death] run effect give @s minecraft:glowing 2 0 true
execute at @s[gamemode=!spectator] positioned ~ ~-1 ~ at @e[type=minecraft:armor_stand,tag=fancy_tp_dead,distance=0..1.2,tag=!fancy_tp_death] run playsound minecraft:block.respawn_anchor.set_spawn ambient @a ~ ~ ~ 4 2
execute at @s[gamemode=!spectator] positioned ~ ~-1 ~ as @e[type=minecraft:armor_stand,tag=fancy_tp_dead,distance=0..1.2,tag=!fancy_tp_death] run tag @s add fancy_tp_death

execute as @e[type=minecraft:armor_stand,tag=fancy_tp_dead,tag=fancy_tp_death] at @s run tp @s ~ ~0.2 ~
execute as @e[type=minecraft:armor_stand,tag=fancy_tp_dead,tag=fancy_tp_death,nbt=!{ActiveEffects:[{Id:24b}]}] at @s run summon firework_rocket ~ ~ ~ {LifeTime:0,CustomName:'{"text":"fdf","underlined":true}',FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:4,Flicker:1b,Trail:1b,Colors:[I;8521479],FadeColors:[I;16711680]}]}}}}
execute as @e[type=minecraft:armor_stand,tag=fancy_tp_dead,tag=fancy_tp_death,nbt=!{ActiveEffects:[{Id:24b}]}] run kill @s

#give effects
effect give @s[scores={fancy_tp_stage=1..}] minecraft:regeneration 1 255 true
effect give @s[scores={fancy_tp_stage=1..}] minecraft:resistance 1 255 true

#secure system if in teleport for too long
execute as @s[scores={fancy_tp_stage=1..2,fancy_tp_safe=500..}] run tellraw @s {"text":"(Fancy tp error) If you got stuck, please report it if it happens often!","color":"dark_red"}
execute as @s[scores={fancy_tp_stage=1..2,fancy_tp_safe=500..}] run effect give @s slow_falling 10 0 false
execute as @s[scores={fancy_tp_stage=1..2,fancy_tp_safe=500..}] run tag @s add fancy_tp_survival
execute as @s[scores={fancy_tp_stage=1..2,fancy_tp_safe=500..}] run tag @s add fancy_tp_cancel

#if sneak spectate armor_stand
execute unless entity @s[tag=fancy_tp_use11] run tag @a[limit=1,sort=random,tag=fancy_tp,scores={fancy_tp_stage=1..}] add fancy_tp_use11
execute as @e[type=armor_stand,tag=fancy_tp_watch_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use11,scores={fancy_tp_sneak=1..}] fancy_tp_pl_id run spectate @s @a[limit=1,tag=fancy_tp_use11,scores={fancy_tp_sneak=1..}]

#target random player and then teleport
execute unless entity @s[tag=fancy_tp_use00] run tag @a[tag=fancy_tp,limit=1,sort=random,scores={fancy_tp_stage=1..4}] add fancy_tp_use00
execute as @e[type=armor_stand,tag=fancy_tp_watch_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use00] fancy_tp_pl_id at @s run tp @a[limit=1,tag=fancy_tp_use00] ~ ~ ~ 90 90
effect give @s[tag=fancy_tp_use00] levitation 5 0 true
tag @s remove fancy_tp_use00



#stage 0, prep teleport mark current location and mark the targeted location
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=0}] run function fancy_teleport:tp_stage_0



#stage 1, teleport player upwards until it hits good y lvl
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=1}] run function fancy_teleport:tp_stage_1



#stage 2, teleport player towards targeted location
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=2}] run function fancy_teleport:tp_stage_2



#stage 3, message player info if nan just skip this stage
#target a random player if message. If no message set stage to 4
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=3}] run function fancy_teleport:tp_stage_3



#stage 4, teleport player downwards until it hits the correct y lvl
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=4}] run function fancy_teleport:tp_stage_4



#stage 5, reset everything! move_to stand, watch_stand, stage, gamemode.
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=5}] run function fancy_teleport:tp_stage_5



#stage 6, load chunks
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=6}] run function fancy_teleport:tp_stage_6
tag @s remove fancy_tp_use11

