


#give random player fancy_tp_cr_pl tags
execute unless entity @a[tag=fancy_tp_cr_pl0] run tag @s[scores={fancy_tp_die=1,fancy_tp_timer=0..},tag=fancy_tp] add fancy_tp_cr_pl0
execute unless entity @a[tag=fancy_tp_cr_pl1] run tag @s[scores={fancy_tp_die=2,fancy_tp_timer=0..},tag=fancy_tp] add fancy_tp_cr_pl1
execute unless entity @a[tag=fancy_tp_cr_pl2] run tag @s[scores={fancy_tp_die=3,fancy_tp_timer=0..},tag=fancy_tp] add fancy_tp_cr_pl2
scoreboard players set @s[scores={fancy_tp_timer=..-1},tag=fancy_tp] fancy_tp_die 0


#Put commands you want to run when a player die under these two lines! Suggested command: "execute if entity @a[tag=fancy_tp_cr_pl0] run <your command>"
#Replace <Your command> with the command you want to run when a player die. To target dead player use this target selector: @a[tag=fancy_tp_cr_pl0]



#when player die, store gamemode, gamemode spectator, visual effects, start timer, and teleport to location before death
execute as @s[tag=fancy_tp_cr_pl0,gamemode=survival] run tag @s add fancy_tp_survival3
execute as @s[tag=fancy_tp_cr_pl0,gamemode=creative] run tag @s add fancy_tp_creative3
execute as @s[tag=fancy_tp_cr_pl0,gamemode=spectator] run tag @s add fancy_tp_spectator3
execute as @s[tag=fancy_tp_cr_pl0,gamemode=adventure] run tag @s add fancy_tp_adventure3
execute as @s[tag=fancy_tp_cr_pl0] run scoreboard players set @s fancy_tp_ask 0
execute as @s[tag=fancy_tp_cr_pl0] run gamemode spectator @s
execute as @s[tag=fancy_tp_cr_pl0] at @s run forceload add ~ ~
execute as @s[tag=fancy_tp_cr_pl0] at @s run summon armor_stand ~ ~ ~ {NoGravity:1b,Invulnerable:1b,Small:1b,Marker:1b,Invisible:1b,PersistenceRequired:1b,Tags:["fancy_tp_respawn","fancy_tp_respawn_prep","fancy_tp_forceload"]}
execute as @s[tag=fancy_tp_cr_pl0] at @s run scoreboard players operation @e[type=minecraft:armor_stand,tag=fancy_tp_respawn_prep,limit=1,sort=nearest,distance=0..2] fancy_tp_en_id = @s fancy_tp_pl_id
execute as @s[tag=fancy_tp_cr_pl0] at @s run tag @e[type=armor_stand,tag=fancy_tp_respawn_prep,limit=1,sort=nearest,distance=0..2] remove fancy_tp_respawn_prep
execute as @e[type=minecraft:armor_stand,tag=fancy_tp_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_cr_pl0] fancy_tp_pl_id at @s run tp @a[tag=fancy_tp_cr_pl0] ~ ~ ~ 
execute as @s[tag=fancy_tp_cr_pl0] at @s run playsound minecraft:entity.iron_golem.death ambient @a ~ ~ ~ 5 0
execute as @s[tag=fancy_tp_cr_pl0] at @s run particle minecraft:elder_guardian ~ ~ ~ 0 0 0 0 1 force @s
execute as @s[tag=fancy_tp_cr_pl0] at @s run summon armor_stand ~ ~-1 ~ {ShowArms:1b,Pose:{Body:[266f,0f,1f],LeftLeg:[175f,0f,0f],RightLeg:[177f,0f,0f],Head:[306f,0f,20f],LeftArm:[254f,300f,0f],RightArm:[100f,220f,360f]},PersistenceRequired:1b,NoBasePlate:1b,ShowArms:1b,Rotation:[6f],ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:4868423}}},{id:"",Count:1b,tag:{display:{color:16639}}},{id:"leather_chestplate",Count:1b,tag:{display:{color:65501}}},{id:"player_head",Count:1b}],HandItems:[{},{}],CustomName:'{"text":"Dead","color":"dark_red","underlined":"true"}',CustomNameVisible:1b,DisabledSlots:4144959,Tags:[fancy_tp_dead],Invulnerable:1b}
execute as @s[tag=fancy_tp_cr_pl0] at @s run particle minecraft:item redstone ~ ~-0.3 ~ 0.4 0.4 0.4 0.3 100 force @a
execute as @s[tag=fancy_tp_cr_pl0] run scoreboard players operation @s fancy_tp_store = @s fancy_tp_timer
execute as @s[tag=fancy_tp_cr_pl0] run scoreboard players set @s fancy_tp_die 2


#while player is dead, decrease timer, text,  
execute as @s[tag=fancy_tp_cr_pl1,scores={fancy_tp_timer=1..}] run title @s subtitle ["",{"text":"Respawning in ","color":"gold"},{"score":{"name":"@s","objective":"fancy_tp_store"},"color":"yellow"},{"text":" Ticks!","color":"gold"}]
execute as @s[tag=fancy_tp_cr_pl1,scores={fancy_tp_timer=1..}] run title @s title {"text":"You Died!","color":"dark_red"}
execute as @s[tag=fancy_tp_cr_pl1] run scoreboard players remove @s fancy_tp_store 1
execute as @s[tag=fancy_tp_cr_pl1,scores={fancy_tp_store=..0}] run scoreboard players set @s fancy_tp_die 3


#when player respawn, reset scores, add tp tags, gamemode stored value
execute as @s[tag=fancy_tp_cr_pl2] run scoreboard players set @s fancy_tp_die 0
execute if entity @s[tag=fancy_tp_cr_pl2] as @e[type=minecraft:armor_stand,tag=fancy_tp_respawn] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_cr_pl2,scores={}] fancy_tp_pl_id at @s run summon armor_stand ~ ~ ~ {NoGravity:1b,Invulnerable:1b,Small:1b,Marker:1b,Invisible:1b,PersistenceRequired:1b,Tags:["fancy_tp_target","fancy_tp_forceload"]}
execute if entity @s[tag=fancy_tp_cr_pl2] as @e[type=minecraft:armor_stand,tag=fancy_tp_respawn] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_cr_pl2,scores={}] fancy_tp_pl_id run kill @s
execute as @s[tag=fancy_tp_cr_pl2,tag=fancy_tp_survival3] run tag @s add fancy_tp_survival
execute as @s[tag=fancy_tp_cr_pl2,tag=fancy_tp_creative3] run tag @s add fancy_tp_creative
execute as @s[tag=fancy_tp_cr_pl2,tag=fancy_tp_spectator3] run tag @s add fancy_tp_spectator
execute as @s[tag=fancy_tp_cr_pl2,tag=fancy_tp_adventure3] run tag @s add fancy_tp_adventure
execute as @s[tag=fancy_tp_cr_pl2] run tag @s add fancy_tp_move


#remove tags from player (run last)
tag @s[tag=fancy_tp_cr_pl2] remove fancy_tp_survival3
tag @s[tag=fancy_tp_cr_pl2] remove fancy_tp_creative3
tag @s[tag=fancy_tp_cr_pl2] remove fancy_tp_adventure3
tag @s[tag=fancy_tp_cr_pl2] remove fancy_tp_spectator3
tag @s remove fancy_tp_cr_pl0
tag @s remove fancy_tp_cr_pl1
tag @s remove fancy_tp_cr_pl2

